//+------------------------------------------------------------------+
//|                                                 VininI_MV_MA.mq4 |
//|                                  opyright 2008. Victor Nicolaev |
//|                                                    vinin.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "opyright 2008. Victor Nicolaev"
#property link      "vinin.ucoz.ru"

#property indicator_separate_window
#property indicator_buffers 1



//---- input parameters


extern string  MA_Symbol   = "";
extern int     MA_Period   = 5;
extern int     MA_Shift    = 0;
extern int     MA_Method   = 0;
extern int     MA_Price    = 0;
extern int     MA_reversi  = 0;

extern int     Limit    =1440;

double MA[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   if (MA_Symbol=="") {MA_Symbol=Symbol(); MA_reversi=1;}
   if (MA_reversi==0) {
      MA_reversi=1;
      if (StringSubstr(MA_Symbol,0,3)==StringSubstr(Symbol(),3,3) || StringSubstr(MA_Symbol,3,3)==StringSubstr(Symbol(),0,3)) MA_reversi=-1;
   }      
   if (MA_Symbol==Symbol()) SetIndexStyle(0,DRAW_LINE,EMPTY,1,Yellow); else SetIndexStyle(0,DRAW_LINE,EMPTY,1,Green);
   SetIndexDrawBegin(0,MA_Period);
   SetIndexBuffer(0,MA);
   IndicatorShortName(MA_Symbol+"("+ MA_Period+")");
   SetIndexLabel(0,MA_Symbol);
   
   return(0); }

//+------------------------------------------------------------------+
int start() {
   static int TimeMA=-1;
   int limit;
   int counted_bars=IndicatorCounted();
   int i, CurrentTime, MAPos;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   if (limit>Limit && Limit>0) limit = Limit;
   if (TimeMA>0) limit+=iBarShift(MA_Symbol,Period(),TimeMA);
   for (i = limit;i>=0;i--){
      CurrentTime=Time[i];
      MAPos=iBarShift(MA_Symbol,Period(),CurrentTime);
      if (iTime(MA_Symbol,Period(),MAPos)<CurrentTime) MAPos++;
      if (MA_reversi==1) MA[i] = iMA( MA_Symbol, 0, MA_Period, MA_Shift, MA_Method, MA_Price, MAPos);
      else MA[i] = 1.0/iMA( MA_Symbol, 0, MA_Period, MA_Shift, MA_Method, MA_Price, MAPos);
   }
   TimeMA=iTime(MA_Symbol,Period(),0);
   

   return(0); 
}// int start()


